Bug 891011 - Review Request: mingw-angleproject - Almost Native Graphics Layer Engine
Summary: Review Request: mingw-angleproject - Almost Native Graphics Layer Engine
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: greg.hellings
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 858058
TreeView+ depends on / blocked
 
Reported: 2012-12-31 19:23 UTC by Erik van Pienbroek
Modified: 2013-02-08 02:04 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-02-08 02:03:55 UTC
greg.hellings: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Erik van Pienbroek 2012-12-31 19:23:26 UTC
Spec URL: http://svn.openftd.org/svn/fedora_cross/mingw-angleproject/mingw-angleproject.spec
SRPM URL: http://koji.vanpienbroek.nl/kojifiles/packages/mingw-angleproject/0/2.svn1561.20121214.fc18/src/mingw-angleproject-0-2.svn1561.20121214.fc18.src.rpm
Fedora Account System Username: epienbro

Description: 
ANGLE is a conformant implementation of the OpenGL ES 2.0 specification that
is hardware‐accelerated via Direct3D. ANGLE v1.0.772 was certified compliant
by passing the ES 2.0.3 conformance tests in October 2011. ANGLE also provides
an implementation of the EGL 1.4 specification.

ANGLE is used as the default WebGL backend for both Google Chrome and
Mozilla Firefox on Windows platforms. Chrome uses ANGLE for all graphics
rendering on Windows, including the accelerated Canvas2D implementation
and the Native Client sandbox environment.

Portions of the ANGLE shader compiler are used as a shader validator and
translator by WebGL implementations across multiple platforms. It is used
on Mac OS X, Linux, and in mobile variants of the browsers. Having one shader
validator helps to ensure that a consistent set of GLSL ES shaders are
accepted across browsers and platforms. The shader translator can be used
to translate shaders to other shading languages, and to optionally apply
shader modifications to work around bugs or quirks in the native graphics
drivers. The translator targets Desktop GLSL, Direct3D HLSL, and even ESSL
for native GLES2 platforms.

== 

This package is required by mingw-qt5-qtbase (bug 858058)

Comment 1 greg.hellings 2013-01-04 16:32:12 UTC
As I asked in IRC, I'm not sure you want versions to be of the type
0-2.svnX.timestamp.dist

If you later update to svnX+1 won't you want to drop back to release -1? With the current scheme 0-1.svnX+1.timestamp.dist will be seen as a lower version number. SVN revision and/or timestamp would need to be before the -1 and -2 in order for revision comparison to sort out properly. Is the current behavior your intention?

-rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
$ rpmlint results_mingw-angleproject/0/2.svn1561.20121214.fc18/mingw*rpm
mingw32-angleproject.noarch: W: spelling-error %description -l en_US conformant -> conform ant, conform-ant, conformance
mingw32-angleproject.noarch: W: spelling-error %description -l en_US backend -> backed, back end, back-end
mingw32-angleproject.noarch: W: spelling-error %description -l en_US shader -> shared, shade, shadier
mingw32-angleproject.noarch: W: spelling-error %description -l en_US validator -> lavatorial
mingw32-angleproject.noarch: W: spelling-error %description -l en_US shaders -> shades, sharers, shavers
mingw32-angleproject.noarch: W: no-documentation
mingw32-angleproject-debuginfo.noarch: E: debuginfo-without-sources
mingw32-angleproject-static.noarch: W: no-documentation
mingw32-angleproject-static.noarch: W: spurious-executable-perm /usr/i686-w64-mingw32/sys-root/mingw/lib/libGLESv2.a
mingw32-angleproject-static.noarch: W: spurious-executable-perm /usr/i686-w64-mingw32/sys-root/mingw/lib/libEGL.a
mingw64-angleproject.noarch: W: spelling-error %description -l en_US conformant -> conform ant, conform-ant, conformance
mingw64-angleproject.noarch: W: spelling-error %description -l en_US backend -> backed, back end, back-end
mingw64-angleproject.noarch: W: spelling-error %description -l en_US shader -> shared, shade, shadier
mingw64-angleproject.noarch: W: spelling-error %description -l en_US validator -> lavatorial
mingw64-angleproject.noarch: W: spelling-error %description -l en_US shaders -> shades, sharers, shavers
mingw64-angleproject.noarch: W: no-documentation
mingw64-angleproject-debuginfo.noarch: E: debuginfo-without-sources
mingw64-angleproject-static.noarch: W: no-documentation
mingw64-angleproject-static.noarch: W: spurious-executable-perm /usr/x86_64-w64-mingw32/sys-root/mingw/lib/libEGL.a
mingw64-angleproject-static.noarch: W: spurious-executable-perm /usr/x86_64-w64-mingw32/sys-root/mingw/lib/libGLESv2.a
mingw-angleproject.src: W: spelling-error %description -l en_US conformant -> conform ant, conform-ant, conformance
mingw-angleproject.src: W: spelling-error %description -l en_US backend -> backed, back end, back-end
mingw-angleproject.src: W: spelling-error %description -l en_US shader -> shared, shade, shadier
mingw-angleproject.src: W: spelling-error %description -l en_US validator -> lavatorial
mingw-angleproject.src: W: spelling-error %description -l en_US shaders -> shades, sharers, shavers
mingw-angleproject.src:171: W: mixed-use-of-spaces-and-tabs (spaces: line 6, tab: line 171)
mingw-angleproject.src: W: invalid-url Source0: angleproject-r1561.tar.bz2
7 packages and 0 specfiles checked; 2 errors, 25 warnings.

It looks like minimally the mixed-use warning can be squashed and the +x should be removed.

+The package must be named according to the Package Naming Guidelines .
+The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. 
+The package must meet the Packaging Guidelines .
+The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
+The License field in the package spec file must match the actual license.
-If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.

The LICENSE file is not included in %doc

+The spec file must be written in American English.
+The spec file for the package MUST be legible.
+The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
+The package MUST successfully compile and build into binary rpms on at least one primary architecture. (I tested x86_64 on f18)
+If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
+All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
+The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
(n/a)Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
+Packages must NOT bundle copies of system libraries.
(n/a) If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
+A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
+A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
+Permissions on files must be set properly. Executables should be set with executable permissions, for example.
+Each package must consistently use macros.
+The package must contain code, or permissable content.
+Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
+If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
+Static libraries must be in a -static package.
(n/a) Development files must be in a -devel package.
(n/a) In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
+Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
+Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
+Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
+All filenames in rpm packages must be valid UTF-8.

Comment 2 Erik van Pienbroek 2013-01-25 19:25:36 UTC
(In reply to comment #1)
> As I asked in IRC, I'm not sure you want versions to be of the type
> 0-2.svnX.timestamp.dist
> 
> If you later update to svnX+1 won't you want to drop back to release -1?
> With the current scheme 0-1.svnX+1.timestamp.dist will be seen as a lower
> version number. SVN revision and/or timestamp would need to be before the -1
> and -2 in order for revision comparison to sort out properly. Is the current
> behavior your intention?

Yes the versioning scheme is intended. Upstream hasn't done any official releases yet so it is completely uncertain what version number will be used first (it might be 1.0, but in might also be 0.0.1). Therefore the version tag will remain at 0 for the time being.

The general rule of thumb for using unreleased versions is by prefixing the release tag with '0.'. Whether this '0.' prefix is used in this package or not doesn't really matter now as the version number is 0. This should be an enough indication that a snapshot is used instead of an official release. However, if it would make you feel better then I can add the '0.' prefix to the release tag.

The svn revision and timestamp which are mentioned in the release tag are only used as additional information to end users. The RPM version check works from left to right when it has to determine which package is more recent. Take for example:

$ rpmdev-vercmp 
  Epoch1: 
Version1: 0
Release1: 2.svn123.20130125.fc19
  Epoch2: 
Version2: 0
Release2: 3.svn124.20130125.fc19
0-2.svn123.20130125.fc19 < 0-3.svn124.20130125.fc19

$ rpmdev-vercmp 
  Epoch1: 
Version1: 0
Release1: 2.svn123.20130125.fc19
  Epoch2: 
Version2: 0
Release2: 3.svn122.20130124.fc19
0-2.svn123.20130125.fc19 < 0-3.svn122.20130124.fc19

As you can see this also gives us the flexibility to downgrade to an older SVN revision if necessary (without having to use the epoch). When the SVN revision is used as first component then downgrading won't be possible:

$ rpmdev-vercmp 
  Epoch1: 
Version1: 0
Release1: svn123.20130125.1.fc19
  Epoch2: 
Version2: 0
Release2: svn122.20130124.2.fc19
0-svn123.20130125.1.fc19 > 0-svn122.20130124.2.fc19

I'll publish an updated package which fixes the permission and spaces/tabs rpmlint warnings

Comment 3 Erik van Pienbroek 2013-01-25 21:09:19 UTC
Updated Spec URL: http://svn.openftd.org/svn/fedora_cross/mingw-angleproject/mingw-angleproject.spec
Updated SRPM URL: http://koji.vanpienbroek.nl/kojifiles/work/tasks/1501/1501/mingw-angleproject-0-0.3.svn1561.20121214.fc18.src.rpm

* Fri Jan 25 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 0-0.3.svn1561.20121214
- Added license
- Resolved various rpmlint warnings
- Prefix the release tag with '0.'

Comment 4 greg.hellings 2013-01-26 16:53:41 UTC
You're happy that the versioning is behaving as you intend and the other issues are cleaned up. Approved.

Comment 5 Erik van Pienbroek 2013-01-26 17:25:17 UTC
Thanks for the review!

New Package SCM Request
=======================
Package Name: mingw-angleproject
Short Description: Almost Native Graphics Layer Engine
Owners: epienbro
Branches: f17 f18
InitialCC:

Comment 6 Gwyn Ciesla 2013-01-27 21:33:19 UTC
Git done (by process-git-requests).

Comment 7 Fedora Update System 2013-01-28 14:40:19 UTC
mingw-qt5-qtbase-5.0.0-3.fc18,mingw-angleproject-0-0.3.svn1561.20121214.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/mingw-qt5-qtbase-5.0.0-3.fc18,mingw-angleproject-0-0.3.svn1561.20121214.fc18

Comment 8 Fedora Update System 2013-01-28 14:44:35 UTC
mingw-headers-2.0.999-0.9.trunk.20121016.fc17,mingw-dbus-1.4.24-1.fc17,mingw-qt5-qtbase-5.0.0-3.fc17,mingw-angleproject-0-0.3.svn1561.20121214.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/mingw-headers-2.0.999-0.9.trunk.20121016.fc17,mingw-dbus-1.4.24-1.fc17,mingw-qt5-qtbase-5.0.0-3.fc17,mingw-angleproject-0-0.3.svn1561.20121214.fc17

Comment 9 Fedora Update System 2013-01-30 00:37:31 UTC
mingw-qt5-qtbase-5.0.0-3.fc18, mingw-angleproject-0-0.3.svn1561.20121214.fc18 has been pushed to the Fedora 18 testing repository.

Comment 10 Fedora Update System 2013-02-08 02:04:00 UTC
mingw-headers-2.0.999-0.9.trunk.20121016.fc17, mingw-dbus-1.4.24-1.fc17, mingw-qt5-qtbase-5.0.0-3.fc17, mingw-angleproject-0-0.3.svn1561.20121214.fc17 has been pushed to the Fedora 17 stable repository.

Comment 11 Fedora Update System 2013-02-08 02:04:44 UTC
mingw-qt5-qtbase-5.0.0-3.fc18, mingw-angleproject-0-0.3.svn1561.20121214.fc18 has been pushed to the Fedora 18 stable repository.


Note You need to log in before you can comment on or make changes to this bug.